%global pkg ast
%global kernel 5.10.134-13.an8
%define anolis_release 1

Name:        kmod-%{pkg}
Version:     %(echo %{kernel} | sed -E 's/-/~/g; s/\.(el|al|alios)[0-9]+$//g')
Release:     %{anolis_release}%{?dist}
Summary:     ASPEED Graphics DRM Driver
License:     LBPLv2+ and MIT
URL:         https://www.aspeedtech.com/support_driver/
Patch0:      source-git.patch

# 安装依赖, 和内核版本对应
Requires:       kernel = %{kernel}
Requires(post): kmod
Requires(post): dracut

# 构建依赖, 和内核版本对应
BuildRequires:    kernel-devel   = %{kernel}
BuildRequires:    kernel-headers = %{kernel}
BuildRequires:    elfutils-libelf-devel
BuildRequires:    gcc
BuildRequires:    kernel-rpm-macros
BuildRequires:    kmod
BuildRequires:    make
BuildRequires:    redhat-rpm-config
BuildRequires:    xz

%description
RPM Package for ASPEED Graphics DRM Driver

%prep
%autosetup -p1 -c -T

%build
pushd src
%{__make} -C /usr/src/kernels/%{kernel}.%{_arch} %{?_smp_mflags} M=$PWD modules
popd

%install
mkdir -p %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/drivers/gpu/drm/ast
%{__install} -D -t %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/drivers/gpu/drm/ast src/ast.ko

# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

# Generate depmod.conf
%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

%clean
%{__rm} -rf %{buildroot}

%post
depmod -a %{kernel}.%{_arch}
dracut -v -f /boot/initramfs-%{kernel}.%{_arch}.img %{kernel}.%{_arch}

%files
%defattr(644,root,root,755)
%license licenses
/lib/modules/%{kernel}.%{_arch}
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}.conf

%changelog
